import torch
import torch_mlu
import torch_mlu_ops as tmo
from common import benchmark_forward, save_to_csv
import argparse
from tabulate import tabulate
import os

e2e_time_param_dict_list = [{"batch": 1, "seq_len": 1024, "input_size": 1600, "hidden_size": 1600,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]},
                            {"batch": 1, "seq_len": 1024, "input_size": 2048, "hidden_size": 2048,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]},
                            {"batch": 1, "seq_len": 1024, "input_size": 4096, "hidden_size": 4096,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]},
                            {"batch": 1, "seq_len": 1024, "input_size": 6144, "hidden_size": 6144,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]},
                            {"batch": 1, "seq_len": 1024, "input_size": 6656, "hidden_size": 6656,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]},
                            {"batch": 1, "seq_len": 1024, "input_size": 8192, "hidden_size": 8192,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]},
                            {"batch": 1, "seq_len": 1024, "input_size": 12288, "hidden_size": 12288,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]},
                            {"batch": 1, "seq_len": 1024, "input_size": 14336, "hidden_size": 14336,
                             "has_residual": True, "has_bias": True, "input_dtype": [torch.float16, torch.bfloat16]}]

def main():
  parser = argparse.ArgumentParser()
  parser.add_argument('--repeat_times', type=int, default=10, help='repeat times for testing')
  parser.add_argument('--csv', action='store_true', help='write the report data to csv')
  parser.add_argument('-o', type=str, help='specify the output folder name under --csv mode')

  args = parser.parse_args()
  device = 'mlu'

  titles = ["batch", "seq_len", "input_size", "hidden_size", "has_residual", "has_bias", "input_dtype", "hardware_time(us)", "e2e_latency(us)"]
  contents = []
  for params_dict in e2e_time_param_dict_list:
    batch = params_dict["batch"]
    seq_len = params_dict["seq_len"]
    input_size = params_dict["input_size"]
    hidden_size = params_dict["hidden_size"]
    has_residual = params_dict["has_residual"]
    has_bias = params_dict["has_bias"]
    input_dtype_list = params_dict["input_dtype"]
    for dtype in input_dtype_list:
      if dtype == torch.bfloat16 and not torch_mlu.mlu.is_bf16_supported():
        continue
      x = torch.randn(batch, seq_len, hidden_size).to(dtype).to(device)
      weight = torch.randn(hidden_size, input_size).to(dtype).to(device)
      residual, bias = None, None
      if has_residual:
        residual = torch.randn(batch, seq_len, hidden_size).to(dtype).to(device)
      if has_bias:
        bias = torch.randn(hidden_size).to(dtype).to(device)
      hardware_time, e2e_time = benchmark_forward(tmo.attention_project,
                                                  x,
                                                  weight,
                                                  bias,
                                                  residual,
                                                  1.0,
                                                  1.0,
                                                  repeats=args.repeat_times)
      content = [f"{batch}", f"{seq_len}", f"{input_size}", f"{hidden_size}", f"{has_residual}", f"{has_bias}", f"{dtype}", f"{hardware_time}", f"{e2e_time}"]
      contents.append(content)
  table = [titles] + contents
  print(tabulate(table, headers="firstrow", tablefmt="grid"))

  if args.csv:
    current_file_path = __file__
    _, file_name = os.path.split(current_file_path)
    save_to_csv(table, args.o, file_name)

if __name__=="__main__":
  main()
